#version 150

uniform sampler2D Sampler0;

uniform vec4 ColorModulator;
uniform float GameTime;

in vec3 Position;
in vec2 texCoord0;
in vec4 vertexColor;
in float isSlot;

out vec4 fragColor;

void main() {
    vec4 color = texture(Sampler0, texCoord0) * vertexColor;
    if (color.a == 0.0) {
        discard;
    }
    // Hide other highlights
    if (color.xyz == vec3(0.9960784314,0.9960784314,0.9960784314)) {
        if (isSlot==1.0) {
            color = vec4(1,1,1,sin(GameTime*5000)*0.1+0.3);
        } else {
            discard;
        }
    }

    float val = sin(GameTime*5000)*0.5+0.5;
    color.xyz += vec3(val,val,val);
    
    fragColor = color * ColorModulator;
}