#version 150

#moj_import <bungeon:noise.glsl>

uniform sampler2D Sampler0;

uniform vec4 ColorModulator;
uniform float GameTime;
vec4 color;

in vec2 texCoord0;
in vec4 vertexColor;

in vec2 coord;
in float isSlot;

out vec4 fragColor;

void noise_layers(float speed, float strength, float size) {
    int dir = 0;
    for (int i = 0; i < 6; i++) {
        vec2 movingUV = coord + vec2(GameTime * sin(dir)*speed, GameTime * cos(dir)*speed);
        float noiseValue = noise(movingUV * size);

        color.xyz += vec3(noiseValue * strength, noiseValue * strength, noiseValue * strength);
        dir += 60;
    }
}

void main() {
    color = texture(Sampler0, texCoord0) * vertexColor;
    if (color.a == 0.0) {
        discard;
    }
    // Hide other highlights
    if (color.xyz == vec3(0.9960784314,0.9960784314,0.9960784314)) {
        if (isSlot==1.0) {
            color = vec4(1,1,1,sin(GameTime*5000)*0.1+0.3);
        } else {
            discard;
        }
    } else if (color.xyz == vec3(0.9960784314,0.9960784314,0.9921568627)) { // Advancement Background
        color.xyz = vec3(0.6,0,0.3);
        noise_layers(30, -.1, 30);
    } else if (color.xyz == vec3(0.9960784314,0.9960784314,0.9882352941)) { // Advancement Background
        color.xyz = vec3(0,0,0.6);
        noise_layers(30, -.1, 30);
    }

    fragColor = color * ColorModulator;
}