#version 150

#moj_import <minecraft:fog.glsl>
#moj_import <bungeon:noise.glsl>

uniform sampler2D Sampler0;

uniform vec4 ColorModulator;
uniform float FogStart;
uniform float FogEnd;
uniform vec4 FogColor;
uniform float GameTime;

in float vertexDistance;
in vec4 vertexColor;
in vec2 texCoord0;

out vec4 fragColor;
in vec2 coord;
in vec2 coord_c;
in float flash;

vec4 color;
void noise_layers(float speed, float strength, float size) {
    int dir = 0;
    for (int i = 0; i < 6; i++) {
        vec2 movingUV = coord + vec2(GameTime * sin(dir)*speed, GameTime * cos(dir)*speed);
        float noiseValue = noise(movingUV * size);

        color.xyz += vec3(noiseValue * strength, noiseValue * strength, noiseValue * strength);
        dir += 60;
    }
}

void main() {
    color = texture(Sampler0, texCoord0) * vertexColor * ColorModulator;
    if (color.a < 0.1) {
        discard;
    }

    vec3 iColor = texture(Sampler0, texCoord0).xyz;
    if(iColor == vec3(0.9960784314,0.9960784314,0.9960784314)) {
        color.xyz = vec3(1,1,1);
        noise_layers(10, -.2, 30);

        /*float value = sqrt(pow(abs(coord_c.x),2)+pow(abs(coord_c.y),2));
        value = sin(10/pow(value,2)+GameTime*10000)*0.5+0.5;
        color.xyz = vec3(value,value,value);*/

        float shade = sqrt(pow(abs(coord_c.x*0.0028),2)+pow(abs(coord_c.y*0.017),2))-0.35;
        shade = smoothstep(0.,0.8,shade)*0.7+0.3;
        color.xyz *= vec3(shade,shade,shade);
    }

    color.xyz += flash;
    fragColor = linear_fog(color, vertexDistance, FogStart, FogEnd, FogColor);
}
